﻿# -*- coding: utf-8 -*-


import copy

#センタリング
#形状の中心（バウンディングボックスの中心）が原点になるように形状を移動します。(ポリゴンメッシュオンリー）

#ローカル座標モードや上位パートに変換がかかっていると結果が不正になります。

#微妙にずれてるよう


def return_henkan_pos(pos,mat):
  #posをmatで変換した座標（タプル）を返す
  tempx=pos[0]
  tempy=pos[1]
  tempz=pos[2]
  x1=mat[0][0]*tempx+mat[1][0]*tempy+mat[2][0]*tempz+mat[3][0]*1
  y1=mat[0][1]*tempx+mat[1][1]*tempy+mat[2][1]*tempz+mat[3][1]*1
  z1=mat[0][2]*tempx+mat[1][2]*tempy+mat[2][2]*tempz+mat[3][2]*1
  return [x1,y1,z1]



xscene=xshade.scene()
ashape=xshade.scene().active_shape()


if ashape.type==7:dousasuru=1


if dousasuru>0:
  #上位パートに変換がかかっているなら動作しない

  if xshade.scene().active_shape().local_to_world_matrix!=((1.0, 0.0, 0.0, 0.0), (0.0, 1.0, 0.0, 0.0), (0.0, 0.0, 1.0, 0.0), (0.0, 0.0, 0.0, 1.0)):
    dousasuru=0
    dialog=xshade.create_dialog()
    dialog.append_push_button('上位パートに変換がかかっているため')
    dialog.append_push_button('スクリプトが実行できません')
    
    dialog.ask('エラー')


if dousasuru==1:

  #初期値
  renzoku=1
  modex=0
  modey=0
  modez=0


  while(renzoku==1):

    #ダイアログを表示
    dialog=xshade.create_dialog()
    idx1=dialog.append_bool('x軸')
    idx2=dialog.append_bool('y軸')
    idx3=dialog.append_bool('z軸')

    dialog.set_value(idx1,modex)
    dialog.set_value(idx2,modey)
    dialog.set_value(idx3,modez)


    kekka=dialog.ask('センタリング')

    if kekka==False:renzoku=0
    else:
      imamode=xscene.is_modify_mode
#      print imamode

      modex=dialog.get_value(idx1)
      modey=dialog.get_value(idx2)
      modez=dialog.get_value(idx3)

      #元の形状をクリップボードにコピー
      ashape.copy()


      #中心座標を求める（グローバル座標）
#      cpos=ashape.center_position
      #ローカル座標に変換
#      henkan=ashape.world_to_local_matrix
#      cpos=return_henkan_pos(cpos,henkan)

      minx=ashape.vertex(0).position[0]
      maxx=ashape.vertex(0).position[0]
      miny=ashape.vertex(0).position[1]
      maxy=ashape.vertex(0).position[1]
      minz=ashape.vertex(0).position[2]
      maxz=ashape.vertex(0).position[2]

      for i in range(ashape.total_number_of_control_points):
        tpos=ashape.vertex(i).position
        if minx>tpos[0]:minx=tpos[0]
        if miny>tpos[1]:miny=tpos[1]
        if minz>tpos[2]:minz=tpos[2]
        if maxx<tpos[0]:maxx=tpos[0]
        if maxy<tpos[1]:maxy=tpos[1]
        if maxz<tpos[2]:maxz=tpos[2]
        cpos=[(maxx+minx)/2,(maxy+miny)/2,(maxz+minz)/2]



      if modex==1:
        idou=[-cpos[0],0,0]
        xscene.move_object([0,0,0],None,None,idou)

      if modey==1:
        idou=[0,-cpos[1],0]
        xscene.move_object([0,0,0],None,None,idou)


      if modez==1:
        idou=[0,0,-cpos[2]]
        xscene.move_object([0,0,0],None,None,idou)



      if imamode==1:xscene.enter_modify_mode()

      #元に戻すか聞く
      dialog=xshade.create_dialog()
      idx3=dialog.append_push_button('処理を確定しますか?')
      kekka=dialog.ask('センタリング')

      if kekka==True:renzoku=0

      if kekka==False:
        idou1=0
        if xshade.scene().active_shape().has_sis==True:
          idou1=1
        xshade.scene().paste()
        xshade.scene().select_sister(1)
        xshade.scene().clear()
        if idou1==1:
          xshade.scene().select_brother()
        if imamode==1:
          xshade.scene().enter_modify_mode()
        ashape=xshade.scene().active_shape() 


